from switss.problem import QSHeur, MILPExact, InverseReachabilityInitializer, InverseFrequencyInitializer, AllOnesInitializer

from pathlib import Path
import itertools

timeout = 20*60

inits = [AllOnesInitializer,
         InverseReachabilityInitializer,
         InverseFrequencyInitializer]

lp_solvers = ["gurobi"]
milp_solvers = ["gurobi"]

heur_instances = [ QSHeur(iterations=5,initializertype=initializer,solver=solver) for\
                   (solver,initializer) in \
                   itertools.product(lp_solvers,inits) ]

exact_instances = [ MILPExact(solver) for (solver) in \
                    milp_solvers ]

# paths to prism-benchmarks
prefix = "./"
prism_dtmcs = prefix + "prism-benchmarks/models/dtmcs/"
prism_mdps = prefix + "prism-benchmarks/models/mdps/"

# path to results
global_json_dir = Path("./data")

#print debug messages
debug = True

# do not stop if data directory exists - rather override old results
override_data = True

#path to comics tool
comics_path = None
