#! /bin/bash

if [ ! -f switss_local_env/bin/activate ]; then
    echo "local switss environment doesn't exist!"
    echo "run setup.sh"
    exit 1
fi

#use the python from the local switss environment (created by setup.sh)
source switss_local_env/bin/activate

systemd-run --scope --quiet --user -p MemoryMax=30G taskset -c 0-3 python benchmarks/bench_switss_main.py --mdps &> logs/mdps.log &
systemd-run --scope --quiet --user -p MemoryMax=30G taskset -c 4-7 python benchmarks/bench_switss_main.py --dtmcs &> logs/dtmcs.log &
systemd-run --scope --quiet --user -p MemoryMax=30G taskset -c 8-11 python benchmarks/bench_comics.py &> logs/comics.log &
systemd-run --scope --quiet --user -p MemoryMax=30G taskset -c 12 python benchmarks/bench_switss_treealgo.py [10,50,90] &> logs/treealgo1.log &
systemd-run --scope --quiet --user -p MemoryMax=30G taskset -c 13 python benchmarks/bench_switss_treealgo.py [20,40,80] &> logs/treealgo2.log &
systemd-run --scope --quiet --user -p MemoryMax=30G taskset -c 14 python benchmarks/bench_switss_treealgo.py [30,60,70] &> logs/treealgo3.log &

# systemd-run --scope --quiet --user -p MemoryMax=30G taskset -c 0-3 python benchmarks/bench_ltlsubsys.py &> logs/ltlsubsys.log &
# systemd-run --scope --quiet --user -p MemoryMax=30G taskset -c 4-7 python benchmarks/bench_brp_labeled.py &> logs/labeled.log &
# systemd-run --scope --quiet --user -p MemoryMax=30G taskset -c 0-7 python benchmarks/bench_exact_longer_to.py &> logs/exact_longer_to.log &
