#!/bin/bash

#python to be used
PYTHON=/usr/local/bin/python3

install_with_treealgo=false

# create a virtual python environment to install specific version of switss

if [ "$install_with_treealgo" = true ] ; then
    # here we have to use --system-site-packages to include graph-tools, which must be installed independently on the machine
    virtualenv switss_local_env --system-site-packages -p $PYTHON
else
    virtualenv switss_local_env -p $PYTHON
fi

source switss_local_env/bin/activate

pip install -r requirements.txt

# if installing with treealgo we need to also install the BDD library dd, which uses cudd in the back
if [ "$install_with_treealgo" = true ] ; then
    pip install -r requirements-treealgo.txt
fi

rm -rf switss

git clone https://github.com/simonjantsch/switss.git switss
cd switss
git checkout 3468f9142a02f0d2b868af8b306dc9a040195c5f
python setup.py install --with-treealg
cd ..

rm -rf prism-benchmarks

git clone https://github.com/prismmodelchecker/prism-benchmarks.git prism-benchmarks
cd prism-benchmarks
git checkout f8293b19d336eb9457695679fe94d3385a7f08ff
cd ..

mkdir logs
